<?php
/* * **************************************************************************** */

//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                     module "mod_search_transitions" v1.0.0                  //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */

if (!defined('VALID_CMS_ADMIN')) {
    die('ACCESS DENIED');
}

$opt = $inCore->request('opt', 'str', 'list');
$item_id = $inCore->request('item_id', 'int', 0);

//ссылка на конфиг модуля
$mod_conf_uri = '?view=modules&do=config&id=' . $id;

//pathway
cpAddPathway('Отображение модуля', '?view=modules&do=edit&id=' . $id);
cpAddPathway('Поисковые переходы', '?view=modules&do=config&id=' . $id);

//просмотр всех переходов
if ($opt == 'list') {

    $toolmenu = array();

    $toolmenu[0]['icon'] = 'install.gif';
    $toolmenu[0]['title'] = 'Настройки модуля';
    $toolmenu[0]['link'] = $mod_conf_uri . '&opt=config';

    $toolmenu[1]['icon'] = 'edit.gif';
    $toolmenu[1]['title'] = 'Редактировать отображение модуля';
    $toolmenu[1]['link'] = '?view=modules&do=edit&id=' . $id;

    $toolmenu[2]['icon'] = 'cancel.gif';
    $toolmenu[2]['title'] = 'Отмена';
    $toolmenu[2]['link'] = '?view=modules';

    cpToolMenu($toolmenu);

    //TABLE COLUMNS
    $fields = array();

    $fields[0]['title'] = 'id';
    $fields[0]['field'] = 'id';
    $fields[0]['width'] = '30';

    $fields[1]['title'] = 'Заголовок';
    $fields[1]['field'] = 'request';
    $fields[1]['width'] = '';
    $fields[1]['link'] = $mod_conf_uri . '&opt=edit_show&item_id=%id%';

    $fields[2]['title'] = 'Поисковик';
    $fields[2]['field'] = 'engine';
    $fields[2]['width'] = '';

    $fields[3]['title'] = 'Целевая страница';
    $fields[3]['field'] = 'target_uri';
    $fields[3]['width'] = '';

    $fields[4]['title'] = 'Количество переходов';
    $fields[4]['field'] = 'hits';
    $fields[4]['width'] = '';

    $fields[5]['title'] = 'Дата последнего перехода';
    $fields[5]['field'] = 'date';
    $fields[5]['width'] = '';


    $fields[6]['title'] = 'Показ';
    $fields[6]['field'] = 'published';
    $fields[6]['width'] = '100';
    $fields[6]['do'] = 'opt';
    $fields[6]['do_suffix'] = '';

    //ACTIONS
    $actions = array();
    $actions[0]['title'] = 'Редактировать';
    $actions[0]['icon'] = 'edit.gif';
    $actions[0]['link'] = $mod_conf_uri . '&opt=edit_show&item_id=%id%';

    $actions[1]['title'] = 'Удалить';
    $actions[1]['icon'] = 'delete.gif';
    $actions[1]['confirm'] = 'Удалить поисковый переход?';
    $actions[1]['link'] = $mod_conf_uri . '&opt=del_item&item_id=%id%';

    //Print table
    cpListTable('cms_search_transitions', $fields, $actions, " 1=1 ", 'id');
}

//настройки модуля
if ($opt == 'config') {

    cpAddPathway('Настройки модуля', '');

    //Меню
    $toolmenu = array();

    $toolmenu[0]['icon'] = 'save.gif';
    $toolmenu[0]['title'] = 'Сохранить';
    $toolmenu[0]['link'] = 'javascript:document.configform.submit()';

    $toolmenu[2]['icon'] = 'cancel.gif';
    $toolmenu[2]['title'] = 'Отмена';
    $toolmenu[2]['link'] = $mod_conf_uri;

    cpToolMenu($toolmenu);

    $module_name = cpModuleById($id);
    if (!$module_name) {
        header('location:index.php?view=modules&do=config&id=' . $id);
    }

    $xml_file = PATH . '/admin/modules/' . $module_name . '/config.xml';

    if (!file_exists($xml_file)) {
        $inCore->halt();
    }

    //если есть запрос на сохранение
    if (cmsCore::inRequest('save_config')) {
        $cfg = array();

        $backend = simplexml_load_file($xml_file);

        foreach ($backend->params->param as $param) {

            $name = (string) $param['name'];
            $type = (string) $param['type'];
            $default = (string) $param['default'];

            if ($type == 'flag' && $default === 'on') {
                $default = 1;
            }
            if ($type == 'flag' && $default === 'off') {
                $default = 0;
            }

            switch ($param['type']) {

                case 'number': $value = $inCore->request($name, 'int', $default);
                    break;
                case 'string': $value = $inCore->request($name, 'str', $default);
                    break;
                case 'flag': $value = $inCore->request($name, 'int', $default);
                    break;
                case 'list': $value = $inCore->request($name, 'str', $default);
                    break;
                case 'list_db': $value = (is_array($_POST[$name]) ? $inCore->request($name, 'array', $default) : $inCore->request($name, 'str', $default));
                    break;
            }

            $cfg[$name] = $value;
        }

        $inCore->saveModuleConfig($id, $cfg);

        cmsCore::addSessionMessage('Настройки модуля успешно сохранены', 'success');
    }

    $cfg = $inCore->loadModuleConfig($id);

    $inCore->loadClass('formgen');

    $formGen = new cmsFormGen($xml_file, $cfg);

    $html = $formGen->getHTML();
    $html = str_ireplace('<input type="hidden" name="do" value="save_auto_config" />', '', $html); //костыль, нам нужен свой $do = 'config'
    echo '<form action="index.php?view=modules&do=config&id=' . $id . '&opt=config" method="post" name="configform" target="_self">';
    echo '<input type="hidden" name="save_config" value="1">';
    echo $html;
    echo '</form>';
}

//редактирование показа поисковых запросов на определенных страницах
if ($opt == 'edit_show') {

    if (!$item_id) {
        $inCore->halt();
    }

    cpAddPathway('Установка показа', '');

    //Меню
    $toolmenu = array();

    $toolmenu[0]['icon'] = 'save.gif';
    $toolmenu[0]['title'] = 'Сохранить';
    $toolmenu[0]['link'] = 'javascript:document.editform.submit()';

    $toolmenu[2]['icon'] = 'cancel.gif';
    $toolmenu[2]['title'] = 'Отмена';
    $toolmenu[2]['link'] = $mod_conf_uri . '&opt=list';

    cpToolMenu($toolmenu);

    //если есть запрос на сохранение
    if (cmsCore::inRequest('save_edit')) {
        $uri = trim($inCore->request('uri', 'str', ''));
        if (!$uri) {
            cmsCore::addSessionMessage('Вы не ввели URI', 'error');
            $inCore->redirect($mod_conf_uri . '&opt=edit_show&item_id=' . $item_id);
        }
        //проверим нет ли ещё этого uri в базе
        $check = array();
        $check = $inDB->get_field('cms_search_transitions_show', " `uri` = '{$uri}' AND `transition_id` = '{$item_id}'", 'id');
        if ($check) {
            cmsCore::addSessionMessage('Данный поисковый запрос уже привязан к URI введенной страницы', 'error');
            $inCore->redirect($mod_conf_uri . '&opt=edit_show&item_id=' . $item_id);
        }
        //сохраняем
        $inDB->query("INSERT INTO `cms_search_transitions_show`
                      SET `uri` = '{$uri}',
                          `transition_id` = '{$item_id}'");

        cmsCore::addSessionMessage('URI успешно сохранен', 'success');
    }

    $item = $inDB->get_fields('cms_search_transitions', " id = '{$item_id}'", '`request`, target_uri');

    //TABLE COLUMNS
    $fields = array();

    $fields[0]['title'] = 'id';
    $fields[0]['field'] = 'id';
    $fields[0]['width'] = '30';
    $fields[1]['title'] = 'URI страницы';
    $fields[1]['field'] = 'uri';
    $fields[1]['width'] = '';
    $fields[1]['link'] = $mod_conf_uri . '&opt=edit_uri&item_id=%id%';
    //ACTIONS
    $actions = array();
    $actions[0]['title'] = 'Удалить URI';
    $actions[0]['icon'] = 'delete.gif';
    $actions[0]['confirm'] = 'Удалить URI?';
    $actions[0]['link'] = $mod_conf_uri . '&opt=del_uri&uri_id=%id%';
    ?>
    <div><h3 class="con_content">Поисковый запрос "<?php echo htmlspecialchars($item['request']); ?>" показывается на страницах</h3></div> 
    <?php
    cpListTable('cms_search_transitions_show', $fields, $actions, " `transition_id` = {$item_id}", 'id');
    ?>
    <div><h3 class="con_content">Добавить новый URI</h3></div>
    <div style="margin-top:5px;">
        <form action="index.php?view=modules&do=config&id=<?php echo $id; ?>&opt=edit_show" method="post" name="editform" target="_self">
            <div  class="hinttext" style="margin-top:15px; margin-bottom:15px; font-size:12px;">
                Введите в поле ниже URI страницы, на которых нужно показывать поисковый переход 
                <a href="<?php echo htmlspecialchars($item['target_uri']); ?>" target="_blank"><b style="color:gray;">"<?php echo htmlspecialchars($item['request']); ?>"</b></a><br>
                Формат ввода URI:<br> 
                <b style="color:gray;">/</b> для главной страницы,<br>
                <b style="color:gray;">/blogs</b> для блогов,<br>
                <b style="color:gray;">/users/vasya</b> для страницы пользователя Вася, и.т.д.<br>
            </div>
            <input type="text" name="uri" maxlenght="200" size="100">
            <br><br><br>
            <input type="hidden" name="save_edit" value="1">
            <input type="hidden" name="item_id" value="<?php echo $item_id; ?>">
            <input type="submit" name="save" value="Сохранить">
        </form>
    </div>
    <?php
}

//удаление поискового перехода
if ($opt == 'del_item') {

    if (!$item_id) {
        $inCore->halt();
    }

    //удаляем сам запрос
    $inDB->query("DELETE FROM `cms_search_transitions` WHERE `id` = '{$item_id}'");
    //удаляем URI, к которым привязан запрос
    $inDB->query("DELETE FROM `cms_search_transitions_show` WHERE `transition_id` = '{$item_id}'");

    cmsCore::addSessionMessage('Поисковый запрос успешно удален', 'success');
    $inCore->redirect($mod_conf_uri . '&opt=list');
}

//показ и скрытие поисковых переходов  
if ($opt == 'hide' || $opt == 'show') {

    if ($opt == 'hide') {
        $published = (int) 0;
    } elseif ($opt == 'show') {
        $published = (int) 1;
    }
    $sql = "UPDATE `cms_search_transitions`
              SET published = {$published}
              WHERE id = {$item_id}";
    $inDB->query($sql);
}

//удаление URI
if ($opt == 'del_uri') {

    $uri_id = $inCore->request('uri_id', 'int', 0);

    if (!$uri_id) {
        $inCore->halt();
    }

    $item_id = $inDB->get_field('`cms_search_transitions_show`', " `id` = {$uri_id}", 'transition_id'); //нужен для редиректа

    $inDB->query("DELETE FROM `cms_search_transitions_show` WHERE `id` = {$uri_id} LIMIT 1");

    cmsCore::addSessionMessage('URI успешно удален', 'success');
    $inCore->redirect($mod_conf_uri . '&opt=edit_show&item_id=' . $item_id);
}

//просмотр всех поисковых запросов, привязанных к  данному ури
if ($opt == 'edit_uri') {
    if (!$item_id) {
        $inCore->halt();
    }
    
    cpAddPathway('Запросы, показываемые на странице', '');

    //ури, к которому привязан поисковый запрос
    $uri = $inDB->get_field('`cms_search_transitions_show`', " `id` = '{$item_id}'", 'uri');
    if (!$uri) {
        $inCore->halt();
    }
    //поисковые запросы, привязанные к данному ури
    $results = array();
    $transitions = array();
    $results = $inDB->get_table('`cms_search_transitions_show`', " `uri` = '{$uri}'", 'transition_id');
    if ($results) {
        foreach ($results as $value) {
            $transitions[] = $value['transition_id'];
        }
    }
    
    //готовим условие для выборки
    $where = '';
    $where = implode(',', $transitions);
    $where = $where ? ' `id` IN ('.$where.')' : ' 1 != 1 ';
    ?>
    <div><h3 class="con_content">Поисковые запросы, показыаемые на странице "<?php echo htmlspecialchars($uri); ?>"</h3></div>
    <?php
    //сам список
    //TABLE COLUMNS
    $fields = array();
    $fields[0]['title'] = 'id';
    $fields[0]['field'] = 'id';
    $fields[0]['width'] = '30';
    $fields[1]['title'] = 'Поисковый запрос';
    $fields[1]['field'] = 'request';
    $fields[1]['width'] = '';
    $fields[1]['link'] = $mod_conf_uri . '&opt=edit_show&item_id=%id%';
    
    //ACTIONS
    $actions = array();
    
    cpListTable('cms_search_transitions', $fields, $actions, " {$where}", 'id');
}
?>