<?php

/* * **************************************************************************** */

//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                     module "mod_search_transitions" v1.0.0                  //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */
if ($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') {
    die();
}
header('Content-Type: text/html; charset=utf-8');
session_start();
define('PATH', $_SERVER['DOCUMENT_ROOT']);
define('HOST', 'http://' . $_SERVER['HTTP_HOST']);

define("VALID_CMS", 1);
include(PATH . '/core/cms.php');
$inCore = cmsCore::getInstance();
$inCore->loadClass('db');
$inCore->loadClass('user');
$inCore->loadClass('page');

$inDB   = cmsDatabase::getInstance();
$inUser = cmsUser::getInstance();

$inUser->update();
if(!$inUser->is_admin){ cmsCore::jsonOutput(array('error' => true, 'text' => 'Только админы имеют доступ к данным.')); }

//конфиг модуля
$module_id = cmsCore::getModuleId('mod_search_transitions');
$cfg = array();
$cfg = $inCore->loadModuleConfig($module_id);

//входные данные
$page = cmsCore::request('page', 'int', 0);
$page = $page ? $page : 1;

//готовим пагинацию
$perpage = $cfg['perpage'] ? $cfg['perpage'] : 10;
$total = $inDB->rows_count('cms_search_transitions', '1=1');
if(!$total){ cmsCore::jsonOutput(array(
                                    'error' => false, 
                                    'html' => 'Поисковых запросов нет')); 
}


//выбираем из базы поисковые переходы для показа
    $inDB->limitPage($page, $perpage);
    $items = array();
    $sql ="SELECT *
           FROM `cms_search_transitions`          
           ORDER BY `hits` DESC";
    
    if ($inDB->limit){
            $sql .= " LIMIT {$inDB->limit}";
        }
           
     $result = $inDB->query($sql);
     if($inDB->num_rows($result)){
        while($item = $inDB->fetch_assoc($result)){
            $item['img'] = preg_replace ('/(search.|.ru|.com|.ua)/iu', '', $item['engine']).'.png';
            $items[] = $item;
        } 
     }


//вывод
ob_start();
$smarty = $inCore->initSmarty('modules', 'mod_search_transitions.tpl');
    $smarty->assign('items', $items);
    $smarty->assign('cfg', $cfg);
    $smarty->assign('module_id', $module_id);
    $smarty->assign('is_admin', $inUser->is_admin);
    $smarty->assign('is_ajax', true);
    $smarty->assign('page', 0); //нужно для пагинации запросов в окне для админа
    $smarty->assign('pagebar', cmsPage::getPagebar($total, $page, $perpage, 'javascript:getAllTransitions(%page%);'));
    $smarty->display('mod_search_transitions.tpl');
    
cmsCore::jsonOutput(array(
                          'error' => false, 
                          'html' => ob_get_clean()));    
    
?>
