<?php
/* * **************************************************************************** */

//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                     module "mod_search_transitions" v1.0.0                  //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */

define('PATH', str_replace('/modules/mod_search_transitions', '', dirname(__FILE__)));
define("VALID_CMS", 1);

$inCore = cmsCore::getInstance();
$inDB = cmsDatabase::getInstance();

$module_id = cmsCore::getModuleId('mod_search_transitions');
if(!$module_id){echo 'Ошибка. Не получен id модуля mod_search_transitions'; return;}

//подключаем конфиг модуля
$cfg = array();
$cfg = $inCore->loadModuleConfig($module_id);

$cfg['del_trans'] = $cfg['del_trans'] ? $cfg['del_trans'] : 10;

//устанавливаем WHERE по интервалу
switch($cfg['del_trans']){
    case 1 : $where = 'DATE_ADD(`date`, INTERVAL 1 DAY) < NOW()'; break;
    case 3 : $where = 'DATE_ADD(`date`, INTERVAL 3 DAY) < NOW()'; break;
    case 7 : $where = 'DATE_ADD(`date`, INTERVAL 7 DAY) < NOW()'; break;
    case 10 : $where = 'DATE_ADD(`date`, INTERVAL 10 DAY) < NOW()'; break;
    case 30 : $where = 'DATE_ADD(`date`, INTERVAL 30 DAY) < NOW()'; break;
    default : $where = 'DATE_ADD(`date`, INTERVAL 10 DAY) < NOW()';
}

//делаем выборку из базы по заданному условию
$sql = "SELECT id
        FROM `cms_search_transitions`
        WHERE {$where}";
$result = $inDB->query($sql);
$ids = array();
if($inDB->num_rows($result)){
    while($item = $inDB->fetch_assoc($result)){
        $ids[] = $item['id'];//айдишки удаляемых записей
    }
}

//если есть $ids, подготовим условие для удаления из табл. cms_search_transitions_show
if($ids){
    $where_2 = 'transition_id IN ('.implode(',', $ids).')';
}

//удаляем из первой таблицы
$inDB->query("DELETE FROM `cms_search_transitions` WHERE {$where}");
//удаляем из второй таблицы
$inDB->query("DELETE FROM `cms_search_transitions_show` WHERE {$where_2}");

return;
?>
