<?php
/* * **************************************************************************** */

//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                     module "mod_search_transitions" v1.0.0                  //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */

function mod_search_transitions($module_id){
    $inCore = cmsCore::getInstance(); // ядро
    $inDB = cmsDatabase::getInstance(); // БД
    $inUser = cmsUser::getInstance();
    
    $cfg = array();
    $cfg = $inCore->loadModuleConfig($module_id); // грузим конфиг модуля
    
    $cfg['limit'] = $cfg['limit'] ? $cfg['limit'] : 5;
    $cfg['orderby'] = $cfg['orderby'] ? $cfg['orderby'] : 'date';
    
    switch ($cfg['orderby']){
        case 'date' : $orderby='7 DESC';          break;
        case 'hits' : $orderby = '6 DESC';            break;
        default : $orderby = '7 DESC';                
    } 
    //выбираем из базы поисковые переходы для показа
    $items = array();
    $sql ="SELECT 1,st.*
           FROM `cms_search_transitions` st
           INNER JOIN `cms_search_transitions_show` sts ON sts.transition_id = st.id 
           WHERE (st.published = 1 AND sts.uri = '{$_SERVER['REQUEST_URI']}')  
           UNION 
           SELECT 2,st.*
           FROM `cms_search_transitions` st
           WHERE st.published = 1
           ORDER BY 1, {$orderby}             
           LIMIT {$cfg['limit']}";
           
     $result = $inDB->query($sql);
     if($inDB->num_rows($result)){
        while($item = $inDB->fetch_assoc($result)){
            $item['img'] = preg_replace ('/(search.|.ru|.com|.ua)/iu', '', $item['engine']).'.png';
            $items[] = $item;
        } 
     }
           
    // выводим в шаблон
    $smarty = $inCore->initSmarty('modules', 'mod_search_transitions.tpl');
    $smarty->assign('items', $items);
    $smarty->assign('cfg', $cfg);
    $smarty->assign('is_admin', $inUser->is_admin);
    $smarty->assign('is_ajax', false);
    $smarty->assign('page', 0); //нужно для пагинации запросов в окне для админа
    $smarty->display('mod_search_transitions.tpl');
    
    return true;
}
?>