<?php

/* * **************************************************************************** */

//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                     plugin "p_search_transitions" v1.0.0                    //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */

class p_search_transitions extends cmsPlugin {

// ==================================================================== //
    public function __construct() {

        parent::__construct();

        // Информация о плагине
        $this->info['plugin'] = 'p_search_transitions';
        $this->info['title'] = 'Поисковые переходы';
        $this->info['description'] = 'Собирает данные о поисковых запросах,по которым пользователи перешли на сайт.
            Для модуля "Поисковые переходы"';
        $this->info['author'] = 'Marat Fatikhov';
        $this->info['version'] = '1.0.0';

        // Настройки по-умолчанию
        // События, которые будут отлавливаться плагином

        $this->events[] = 'GET_INDEX';
    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install() {
        $install = parent::install();
        if ($install) {
            $inDB = cmsDatabase::getInstance();

            $inDB->query("CREATE TABLE IF NOT EXISTS `cms_search_transitions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `target_uri` varchar(200) NOT NULL,
  `engine` varchar(60) NOT NULL,
  `request` varchar(255) NOT NULL,
  `hits` int(5) unsigned NOT NULL,
  `date` datetime NOT NULL,
  `published` int(1) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
            $inDB->query("CREATE TABLE IF NOT EXISTS `cms_search_transitions_show` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uri` varchar(200) NOT NULL,
  `transition_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
            $inDB->query("INSERT INTO `cms_cron_jobs` 
(`job_name`, `job_interval`,`custom_file`, `is_enabled`, `is_new`, `comment`) 
VALUES('clear_st_table', 24, 'modules/mod_search_transitions/clear_st_table.php', 0, 1, 'Удаляет устарешие записи с таблиц плагина и модуля \"Поисковые переходы\"'); ");
        }
        return $install;
    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade() {

        return parent::upgrade();
    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item) {

        parent::execute();

        $this->getSearchTransitions();

        return $item;
    }

// ==================================================================== //

    private function getSearchTransitions() {

        $inDB = cmsDatabase::getInstance();
        //получаем текущий ури и урл перехода
        $request_uri = cmsCore::strClear($_SERVER['REQUEST_URI']);
        $refer = cmsCore::strClear($_SERVER['HTTP_REFERER']);

        if (!$refer)
            return;
        //парсим урл
        $parsed = array();
        $parsed = parse_url($refer);
        //если нет параметров в ури, выходим
        if (!isset($parsed['query']))
            return;
        //определяем поисковик
        $engines = array(
            'yandex.ru' => 'text',
            'yandex.ua' => 'text',
            'google.ru' => 'q',
            'google.com' => 'q',
            'google.com.ua' => 'q',
            'mail.ru' => 'q',
            'rambler.ru' => 'words',
            'aport.ru' => 'r',
            'live.com' => 'q',
            'webalta.com' => 'q',
            'yahoo.com' => 'p',
            'nigma.ru' => 's',
            'altavista.com' => 'q',
            'msn.com' => 'q',
            'search.icq.com' => 'q',
            'search.qip.ru' => 'query',
            'vkontakte.ru' => 'to',
            'bing.com' => 'q'
        );
        //перебираем поисковики и определяем есть ли в hostname
        $engine = '';
        $name_var = '';
        foreach ($engines as $key => $value) {
            if (mb_stripos($parsed['host'], $key) !== false) {
                $engine = $key;
                //google.ru и google.com - один и тот же поисковик, 
                //закомментируйте ниже две строчки, если нужно записывать в базу отдельно.
                //if($engine == 'google.ru' || $engine == 'google.com.ua') $engine = 'google.com';
                //if($engine == 'yandex.ua') $engine = 'yandex.ru';
                $var_name = $value;
            }
        }
        //если пришли не с поисковика, выходим
        if (!$engine || !$var_name)
            return;
        //парсим параметры
        $params = array();
        if (!mb_parse_str($parsed['query'], $params))
            return;
        //сам поисковый запрос
        $search = isset($params["{$var_name}"]) ? cmsCore::strClear($params["{$var_name}"]) : '';
        if (!$search)
            return; //пустой поисковый запрос

            
//проверяем есть ли уже в базе данный запрос
        $sql = "SELECT id
                FROM `cms_search_transitions`
                WHERE target_uri = '{$request_uri}' AND engine = '{$engine}' AND request = '$search'
                LIMIT 1";

        $result = $inDB->query($sql);
        if ($inDB->num_rows($result)) {//запрос уже есть в базе, обновляем
            $existing = array();
            $existing = $inDB->fetch_assoc($result);
            $upd_sql = "UPDATE `cms_search_transitions`
                           SET hits = hits + 1,
                               date = NOW()
                           WHERE id = '{$existing['id']}'";
            $inDB->query($upd_sql);
        } else {//запроса ещё нет, заносим
            $ins_sql = "INSERT INTO `cms_search_transitions`
                        SET target_uri = '{$request_uri}',
                            engine = '{$engine}',
                            request = '{$search}',
                            hits = 1,
                            date = NOW(),
                            published = 1";
            $inDB->query($ins_sql);
        }
    }

}

//class
?>